<?php
/*
Plugin Name: SSL Login in Subdomain
Plugin URI: http://arturoemilio.es
Description: Ensures logins are always done via SSL on a chosen subdomain .
Version: 1.0
Author: Arturo
Author URI: http://arturoemilio.es
License: GPL2
*/

register_activation_hook(__FILE__ ,'install');

add_action( 'network_admin_menu', 'subdomain_ssl_menu');
function subdomain_ssl_menu() {
add_submenu_page( 'settings.php', 'Subdomain SSL', 'Subdomain SSL',
		 'install_plugins', 'subdomain_sll', 'subdomain_ssl_opt' );
}

function subdomain_ssl_opt(){
	global $table_prefix, $wpdb;  	 
	$hd = 'submit1';
	$blog = get_site_option('ssl_login_blog');
	
	if(!ctype_digit($blog))
		unset ($blog);
		
	if($_POST[ $hd ] == '1'  ) {
		$blog = $_POST['blog'];
		$url = get_blogaddress_by_id( $blog );
		update_site_option('ssl_login_blog_main',get_current_blog_id());
		update_site_option('ssl_login_blog',$blog) ;
	?><div id="message" class="updated fade"><p><strong>Saved.</strong></p></div><?php } ?>
	
	<h2>Login on SubDomain  </h2><small><a href="http://arturoemilio.es">(click here to visit my website for support o questions)</a></small>

	<form name="forma" method="post" action="<?php echo $_SERVER['REQUEST_URI']; ?>">
	<input type="hidden" name="<?php echo $hd; ?>" value="1">
	
	<table class="form-table" style="border-bottom: 1px solid #aaa">
	<tr valign="top">
	<th scope="row">Blog to use as Log in</th>
	<td>
		<?php
		$blogs = array();
		$id = get_current_user_id();
		$blogs = get_blogs_of_user( $id );
		$main = network_site_url();
		$default = get_site_option('ssl_login_blog');
	?>	
	<select name="blog">
		<?php
		
		if(!$default)
			echo '<option selected>';
		foreach($blogs as $blog){
		$site = $blog->siteurl.'/';
		if ($main != $site){
			if ($blog->userblog_id == $default)
				echo '<option selected value="'. $blog->userblog_id .'">'.$blog->blogname.'('.$site .')';
			else
				echo '<option value="'. $blog->userblog_id .'">'.$blog->blogname.'('.$site .')';
		}
	} ?>
</select>	
	</td>
	</tr>
	<tr><td><input type="submit" class="button-primary" value="Save Options" /></td></tr>
	</table>
	</form>	
	<?php      		    
		}

function wplogin_function_subdomain_ssl($url)
{
	$blog = get_site_option('ssl_login_blog');
	if ($blog && ctype_digit($blog)){
		$url = get_blogaddress_by_id( $blog );	
		$url = $url ."wp-content/plugins/SSL_Login/wp-login.php";
		return preg_replace('/^http:\/\//', 'https://', $url);
	}else{
		return $url;
	}
}
function suscribe_subdomain_ssl($id){
	$user_id = $id; 
	$blog_id = get_site_option('ssl_login_blog');
	$role = 'suscriber';
	add_user_to_blog( $blog_id, $user_id, $role );
	
	$main = get_site_option('ssl_login_blog_main');
	$result = add_user_to_blog( $main, $user_id, $role );
}

add_filter('login_url', 'wplogin_function_subdomain_ssl');
add_action('user_register', 'suscribe_subdomain_ssl');

add_action('parse_request', 'Subdomain_redirect_ssl');
function Subdomain_redirect_ssl(){
	$blog = get_site_option('ssl_login_blog');
	$actual = get_current_blog_id();
    if( $blog == $actual){
	$url = get_blogaddress_by_id( $blog );
        $url = $url ."wp-content/plugins/SSL_Login/wp-login.php";
	$url = preg_replace('/^http:\/\//', 'https://', $url);
        wp_redirect($url, 301);
        exit;
    }
}

add_action('init', 'Subdomain_redirect_all');
function Subdomain_redirect_all(){
	$blog = get_site_option('ssl_login_blog');
	$actual = get_current_blog_id();
    if( $blog == $actual) return;
    
    if (strpos($_SERVER['REQUEST_URI'],'wp-login.php') && !($_SERVER['QUERY_STRING'])){
	$blog = get_site_option('ssl_login_blog');
	$url = get_blogaddress_by_id( $blog );
        $url = $url ."wp-content/plugins/SSL_Login/wp-login.php";
	$url = preg_replace('/^http:\/\//', 'https://', $url);
        wp_redirect($url, 301);
       exit;
     
    }

}





?>